import { Editor } from "codemirror";
export declare type CMEvents = "changes" | "scroll" | "beforeChange" | "cursorActivity" | "keyHandled" | "inputRead" | "electricInput" | "beforeSelectionChange" | "viewportChange" | "swapDoc" | "gutterClick" | "gutterContextMenu" | "focus" | "blur" | "refresh" | "optionChange" | "scrollCursorIntoView" | "update";
interface ComponentsEvts {
    "update:value": (value: string) => string;
    change: (value: string, cm: Editor) => {
        value: string;
        cm: Editor;
    };
    input: (value: string) => string;
    ready: (cm: Editor) => Editor;
    [key: string]: any;
}
export declare const componentsEvts: ComponentsEvts;
export declare const cmEvts: string[];
export declare const getCmEvts: () => {
    [key: string]: () => void;
};
export declare const DEFAULT_OPTIONS: {
    mode: string;
    theme: string;
    lineNumbers: boolean;
    smartIndent: boolean;
    indentUnit: number;
    foldGutter: boolean;
    matchBrackets: boolean;
    autoCloseBrackets: boolean;
    styleActiveLine: boolean;
};
export {};
